//+------------------------------------------------------------------+
//|                                                Comment Table.mq5 |
//|                                            Copyright 2012, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
//#property script_show_inputs
class CommTable
  {
   long              chid;
   int               m,n,dd;
   string            mem[],name;
   color             clrmem[];
   string            ObjLabel(int n,bool create=true);
   void              Cell(int i,int j);
   long              Xdist,Xsize;
   long              Ydist,Ysize;
   color             color_tab;
   long              fond_size_tab;
   string            fond;
public:
                     CommTable(void){chid=0; fond="Courier New"; fond_size_tab=10; color_tab=clrSilver; dd=0; Xdist=0; Ydist=0;};
                    ~CommTable(void){};
   void              SetResize(int m_,int n_)
     {
      m=m_; n=n_; ArrayResize(mem,m*n); ArrayResize(clrmem,m*n);
      for(int i=0;i<m*n;i++)
         clrmem[i]=color_tab;
     };
   void              SetCell(string val,int i,int j,color clrCell){mem[i*n+j]=val; clrmem[i*n+j]=clrCell;};
   void              SetCell(long val,int i,int j,color clrCell){SetCell(IntegerToString(val,dd),i,j); clrmem[i*n+j]=clrCell;};
   void              SetCell(double val,int i,int j,color clrCell){SetCell(DoubleToString(val,dd),i,j); clrmem[i*n+j]=clrCell;};
   void              SetCell(string val,int i,int j){mem[i*n+j]=val;};
   void              SetCell(long val,int i,int j){SetCell(IntegerToString(val,dd),i,j);};
   void              SetCell(double val,int i,int j){SetCell(DoubleToString(val,dd),i,j);};
   void              SetCellColor(int i,int j,color clrCell)
     {
      clrmem[i*n+j]=clrCell;
      ObjectSetInteger(chid,ObjLabel(i*n+j),OBJPROP_COLOR,clrmem[i*n+j]);
     };
   void              SetParam(long chid_,
                              long Xdist_,long Ydist_,
                              long Xsize_,long Ysize_,
                              string fond_,long fond_size_tab_,
                              color color_tab_);
   void              SetParam(long chid_,
                              long Xdist_,long Ydist_,
                              long Xsize_,long Ysize_,
                              string fond_,long fond_size_tab_);
   void              DigitsCell(int dd_){dd=dd_;};
   void              TableName(string name_){name=name_;};
   void              CommentTable();
   void              DeleteTable();
   color             ColorTable(){return(color_tab);};
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CommTable::DeleteTable()
  {
   for(int i=0;i<m*n;i++)
      ObjectDelete(chid,ObjLabel(i,false));
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string CommTable::ObjLabel(int n,bool create=true)
  {
   string nameobj=name+(string)n;
   if(ObjectFind(chid,nameobj)<0 && create)
     {
      if(ObjectCreate(chid,nameobj,OBJ_LABEL,0,0,0,0,0))
        {
         ObjectSetInteger(chid,nameobj,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chid,nameobj,OBJPROP_ANCHOR,ANCHOR_RIGHT_UPPER);
         ObjectSetInteger(chid,nameobj,OBJPROP_FONTSIZE,fond_size_tab);
         ObjectSetString(chid,nameobj,OBJPROP_FONT,fond);
        }
     }
   return(nameobj);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CommTable::SetParam(long chid_,
                         long Xdist_,long Ydist_,
                         long Xsize_,long Ysize_,
                         string fond_,long fond_size_tab_)
  {
   chid=chid_;
   Xdist=Xdist_+Xsize_; Xsize=Xsize_;
   Ydist=Ydist_; Ysize=Ysize_;
   if((bool)ChartGetInteger(chid,CHART_SHOW_OHLC))Ydist+=10;
   color_tab=(color)ChartGetInteger(chid,CHART_COLOR_FOREGROUND);
   fond_size_tab=fond_size_tab_;
   fond=fond_;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CommTable::SetParam(long chid_,
                         long Xdist_,long Ydist_,
                         long Xsize_,long Ysize_,
                         string fond_,long fond_size_tab_,
                         color color_tab_)
  {
   chid=chid_;
   Xdist=Xdist_+Xsize_; Xsize=Xsize_;
   Ydist=Ydist_; Ysize=Ysize_;
   color_tab=color_tab_;
   fond_size_tab=fond_size_tab_;
   fond=fond_;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CommTable::Cell(int i,int j)
  {
   string name=ObjLabel(i*n+j);
   ObjectSetInteger(chid,name,OBJPROP_XDISTANCE,Xdist+Xsize*j);
   ObjectSetInteger(chid,name,OBJPROP_YDISTANCE,Ydist+Ysize*i);
   ObjectSetInteger(chid,name,OBJPROP_COLOR,clrmem[i*n+j]);
   ObjectSetString(chid,name,OBJPROP_TEXT,mem[i*n+j]);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CommTable::CommentTable()
  {
   for(int i=0;i<m;i++)
      for(int j=0;j<n;j++)
         Cell(i,j);
   ChartRedraw(chid);
  };
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   CommTable com;
   com.TableName("##"); com.DigitsCell(1);
   com.SetParam(ChartID(),// ID 
                5,//     X
                5,//     Y
                45,//     X 
                15,//     Y 
                "Tahoma",7);//  
//              "Courier New"
//---            
   int m=20,n=10;
   com.SetResize(m,n);
//---      
   int cnt=0;  
   for(int i=0;i<m;i++)
      for(int j=0;j<n;j++)
         {com.SetCell((double)cnt,i,j);cnt++;}
//---       
   bool ff=true; double dig=2.;
   int i=0,j=0; cnt=0; color Color=clrRed; bool clr=true,black=true;
   while(!IsStopped())
     {
      if(cnt>250){cnt=0; if(black--)Color=com.ColorTable(); else{if(clr--)Color=clrBlue; else Color=clrRed;}}
      if(ff--)dig=2.; else dig=2048.;
      com.SetCellColor(i,j,Color);//     
      i=rand()%m; j=rand()%n; //   
      com.SetCell((double)rand()/dig,i,j,clrYellow);//    
      com.CommentTable();//   
      Sleep(1);
      cnt++;
     }
   com.DeleteTable(); //     
   
  }
//+------------------------------------------------------------------+
